<!DOCTYPE html>
<html><head><title>controllers\todoCtrl.js
 - Stryker report</title>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<link rel="stylesheet" href="../strykerResources/bootstrap/css/bootstrap.min.css">
<link rel="stylesheet" href="../strykerResources/highlightjs/styles/default.css">
<link rel="stylesheet" href="../strykerResources/stryker.css"></head>
<body><img class="stryker-image" alt="Stryker" src="../strykerResources/stryker-80x80.png">
<div class="container-fluid"><div class="row"><div class="col-lg-12"><h1 class="display-4">controllers\todoCtrl.js
 
<small class="text-muted">- Stryker report</small></h1></div></div>
<ol class="breadcrumb"><li class="breadcrumb-item"><a href="../index.html">All files</a></li>
<li class="breadcrumb-item active">controllers\todoCtrl.js</li></ol>
<div class="row"><div class="col-lg-12"><div class="row"><div class="col-sm-11"><table class="table table-sm table-hover table-bordered table-no-top"><thead><tr><th style="width: 20%"><div><span>File / Directory</span></div></th>
<th colspan="2"><div><span>Mutation score</span></div></th>
<th class="rotate text-center" style="width: 50px"><div><span># Killed</span></div></th>
<th class="rotate text-center" style="width: 50px"><div><span># Survived</span></div></th>
<th class="rotate text-center" style="width: 50px"><div><span># Timeout</span></div></th>
<th class="rotate text-center" style="width: 50px"><div><span># No coverage</span></div></th>
<th class="rotate text-center" style="width: 50px"><div><span># Runtime errors</span></div></th>
<th class="rotate text-center" style="width: 50px"><div><span># Transpile errors</span></div></th>
<th class="rotate rotate-width-70 text-center" style="width: 70px"><div><span>Total detected</span></div></th>
<th class="rotate rotate-width-70 text-center" style="width: 70px"><div><span>Total undetected</span></div></th>
<th class="rotate rotate-width-70 text-center" style="width: 70px"><div><span>Total mutants</span></div></th></tr></thead>
<tbody><tr><td>controllers\todoCtrl.js</td>
<td><div class="progress"><div class="progress-bar bg-warning" role="progressbar" aria-valuenow="66.13" aria-valuemin="0" aria-valuemax="100" style="width: 66.13%;">66.13
%</div></div></td>
<th class="text-center text-warning" style="width: 10%">66.13</th>
<td class="text-center">29</td>
<td class="text-center">20</td>
<td class="text-center">12</td>
<td class="text-center">1</td>
<td class="text-center">0</td>
<td class="text-center">0</td>
<th class="text-center">41</th>
<th class="text-center">21</th>
<th class="text-center">62</th></tr>
</tbody></table></div></div>
<div class="row"><div class="col-lg-7"><div class="row legend"><form class="col-md-12" novalidate="novalidate"><div class="form-check form-check-inline"><label class="form-check-label"><input class="form-check-input stryker-display" checked value="0" type="checkbox">
NoCoverage
 
(1)</label></div>
<div class="form-check form-check-inline"><label class="form-check-label"><input class="form-check-input stryker-display" checked value="2" type="checkbox">
Survived
 
(20)</label></div>
<div class="form-check form-check-inline"><label class="form-check-label"><input class="form-check-input stryker-display" value="1" type="checkbox">
Killed
 
(29)</label></div>
<div class="form-check form-check-inline"><label class="form-check-label"><input class="form-check-input stryker-display" value="3" type="checkbox">
TimedOut
 
(12)</label></div>


<a href="#" class="stryker-collapse-expand-all">Expand all</a></form></div>
<pre><code class="lang-javascript"><span class="bg-null">/*global angular */

/**
 * The main controller for the app. The controller:
 * - retrieves and persists the model via the todoStorage service
 * - exposes the model to the template and provides event handlers
 */
angular.module(&#039;todomvc&#039;)
	.controller(&#039;TodoCtrl&#039;, function TodoCtrl($scope, $routeParams, $filter, store) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="0"><span class="badge badge-warning">0</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="0">{
}</span><span class="stryker-original-code" data-mutant="0"><span class="bg-warning-light">{
		&#039;use strict&#039;;

		var todos = $scope.todos = store.todos;

		$scope.newTodo = &#039;&#039;;
		$scope.editedTodo = null;

		$scope.$watch(&#039;todos&#039;, function () </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="1"><span class="badge badge-warning">1</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="1">{
}</span><span class="stryker-original-code" data-mutant="1"><span class="bg-warning-light">{
			$scope.remainingCount = $filter(&#039;filter&#039;)(todos, { completed: </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="2"><span class="badge badge-warning">2</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="2">true</span><span class="stryker-original-code" data-mutant="2"><span class="bg-warning-light">false</span></span><span class="bg-warning-light"> }).length;
			$scope.completedCount = </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BinaryOperator" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="3"><span class="badge badge-warning">3</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="3">todos.length + $scope.remainingCount</span><span class="stryker-original-code" data-mutant="3"><span class="bg-warning-light">todos.length - $scope.remainingCount</span></span><span class="bg-warning-light">;
			$scope.allChecked = </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="4"><span class="badge badge-warning">4</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="4">$scope.remainingCount</span><span class="stryker-original-code" data-mutant="4"><span class="bg-warning-light">!$scope.remainingCount</span></span><span class="bg-warning-light">;
		}</span></span><span class="bg-warning-light">, </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="5"><span class="badge badge-warning">5</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="5">false</span><span class="stryker-original-code" data-mutant="5"><span class="bg-warning-light">true</span></span><span class="bg-warning-light">);

		// Monitor the current route for changes and adjust the filter accordingly.
		$scope.$on(&#039;$routeChangeSuccess&#039;, function () </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="6"><span class="badge badge-warning">6</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="6">{
}</span><span class="stryker-original-code" data-mutant="6"><span class="bg-warning-light">{
			var status = $scope.status = </span><a href="#" class="stryker-mutant-button" tabindex="0" title="LogicalOperator" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="7"><span class="badge badge-warning">7</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="7">$routeParams.status &amp;&amp; &#039;&#039;</span><span class="stryker-original-code" data-mutant="7"><span class="bg-warning-light">$routeParams.status || &#039;&#039;</span></span><span class="bg-warning-light">;
			$scope.statusFilter = (</span><a href="#" class="stryker-mutant-button" tabindex="0" title="BinaryOperator" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="8"><span class="badge badge-success">8</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="8">status !== &#039;active&#039;</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="9"><span class="badge badge-warning">9</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="9">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="10"><span class="badge badge-warning">10</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="10">true</span><span class="stryker-original-code" data-mutant="8"><span class="stryker-original-code" data-mutant="9"><span class="stryker-original-code" data-mutant="10"><span class="bg-warning-light">status === &#039;active&#039;</span></span></span></span><span class="bg-warning-light">) ?
				{ completed: </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="11"><span class="badge badge-success">11</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="11">true</span><span class="stryker-original-code" data-mutant="11"><span class="bg-warning-light">false</span></span><span class="bg-warning-light"> } : (</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="12"><span class="badge badge-success">12</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="12">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="BinaryOperator" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="13"><span class="badge badge-success">13</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="13">status !== &#039;completed&#039;</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="14"><span class="badge badge-success">14</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="14">true</span><span class="stryker-original-code" data-mutant="12"><span class="stryker-original-code" data-mutant="13"><span class="stryker-original-code" data-mutant="14"><span class="bg-warning-light">status === &#039;completed&#039;</span></span></span></span><span class="bg-warning-light">) ?
				{ completed: </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="15"><span class="badge badge-success">15</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="15">false</span><span class="stryker-original-code" data-mutant="15"><span class="bg-warning-light">true</span></span><span class="bg-warning-light"> } : {};
		}</span></span><span class="bg-warning-light">);

		$scope.addTodo = function () </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="16"><span class="badge badge-success">16</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="16">{
}</span><span class="stryker-original-code" data-mutant="16"><span class="bg-warning-light">{
			var newTodo = {
				title: $scope.newTodo.trim(),
				completed: </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="17"><span class="badge badge-danger">17</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="17">true</span><span class="stryker-original-code" data-mutant="17"><span class="bg-danger-light">false</span></span><span class="bg-warning-light">
			};

			if (</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="18"><span class="badge badge-success">18</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="18">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="19"><span class="badge badge-success">19</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="19">true</span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="20"><span class="badge badge-success">20</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="20">newTodo.title</span><span class="stryker-original-code" data-mutant="18"><span class="stryker-original-code" data-mutant="19"><span class="stryker-original-code" data-mutant="20"><span class="bg-warning-light">!newTodo.title</span></span></span></span><span class="bg-warning-light">) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="21"><span class="badge badge-success">21</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="21">{
}</span><span class="stryker-original-code" data-mutant="21"><span class="bg-warning-light">{
				return;
			}</span></span><span class="bg-warning-light">

			$scope.saving = </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="22"><span class="badge badge-danger">22</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="22">false</span><span class="stryker-original-code" data-mutant="22"><span class="bg-danger-light">true</span></span><span class="bg-warning-light">;
			store.insert(newTodo)
				.then(function success() </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="23"><span class="badge badge-danger">23</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="23">{
}</span><span class="stryker-original-code" data-mutant="23"><span class="bg-danger-light">{
					$scope.newTodo = &#039;&#039;;
				}</span></span><span class="bg-warning-light">)
				.finally(function () </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="24"><span class="badge badge-danger">24</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="24">{
}</span><span class="stryker-original-code" data-mutant="24"><span class="bg-danger-light">{
					$scope.saving = </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="25"><span class="badge badge-danger">25</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="25">true</span><span class="stryker-original-code" data-mutant="25"><span class="bg-danger-light">false</span></span><span class="bg-danger-light">;
				}</span></span><span class="bg-warning-light">);
		}</span></span><span class="bg-warning-light">;

		$scope.editTodo = function (todo) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="26"><span class="badge badge-success">26</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="26">{
}</span><span class="stryker-original-code" data-mutant="26"><span class="bg-warning-light">{
			$scope.editedTodo = todo;
			// Clone the original todo to restore it on demand.
			$scope.originalTodo = angular.extend({}, todo);
		}</span></span><span class="bg-warning-light">;

		$scope.saveEdits = function (todo, event) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="27"><span class="badge badge-success">27</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="27">{
}</span><span class="stryker-original-code" data-mutant="27"><span class="bg-warning-light">{
			// Blur events are automatically triggered after the form submit event.
			// This does some unfortunate logic handling to prevent saving twice.
			if (</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="28"><span class="badge badge-danger">28</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="28">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="29"><span class="badge badge-success">29</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="29">true</span><a href="#" class="stryker-mutant-button" tabindex="0" title="LogicalOperator" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="30"><span class="badge badge-danger">30</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="30">event === &#039;blur&#039; || $scope.saveEvent === &#039;submit&#039;</span><a href="#" class="stryker-mutant-button" tabindex="0" title="BinaryOperator" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="31"><span class="badge badge-danger">31</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="31">event !== &#039;blur&#039;</span><span class="stryker-original-code" data-mutant="28"><span class="stryker-original-code" data-mutant="29"><span class="stryker-original-code" data-mutant="30"><span class="stryker-original-code" data-mutant="31"><span class="bg-danger-light">event === &#039;blur&#039;</span></span><span class="bg-danger-light"> &amp;&amp; </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BinaryOperator" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="32"><span class="badge badge-danger">32</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="32">$scope.saveEvent !== &#039;submit&#039;</span><span class="stryker-original-code" data-mutant="32"><span class="bg-danger-light">$scope.saveEvent === &#039;submit&#039;</span></span></span></span></span><span class="bg-warning-light">) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="33"><span class="badge badge-danger">33</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="33">{
}</span><span class="stryker-original-code" data-mutant="33"><span class="bg-danger-light">{
				$scope.saveEvent = null;
				return;
			}</span></span><span class="bg-warning-light">

			$scope.saveEvent = event;

			if (</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="34"><span class="badge badge-danger">34</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="34">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="35"><span class="badge badge-success">35</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="35">true</span><span class="stryker-original-code" data-mutant="34"><span class="stryker-original-code" data-mutant="35"><span class="bg-danger-light">$scope.reverted</span></span></span><span class="bg-warning-light">) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="36"><span class="badge badge-danger">36</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="36">{
}</span><span class="stryker-original-code" data-mutant="36"><span class="bg-danger-light">{
				// Todo edits were reverted-- don&#039;t save.
				$scope.reverted = null;
				return;
			}</span></span><span class="bg-warning-light">

			todo.title = todo.title.trim();

			if (</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="37"><span class="badge badge-danger">37</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="37">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="38"><span class="badge badge-success">38</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="38">true</span><a href="#" class="stryker-mutant-button" tabindex="0" title="BinaryOperator" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="39"><span class="badge badge-success">39</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="39">todo.title !== $scope.originalTodo.title</span><span class="stryker-original-code" data-mutant="37"><span class="stryker-original-code" data-mutant="38"><span class="stryker-original-code" data-mutant="39"><span class="bg-danger-light">todo.title === $scope.originalTodo.title</span></span></span></span><span class="bg-warning-light">) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="40"><span class="badge badge-danger">40</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="40">{
}</span><span class="stryker-original-code" data-mutant="40"><span class="bg-danger-light">{
				$scope.editedTodo = null;
				return;
			}</span></span><span class="bg-warning-light">

			store[</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="41"><span class="badge badge-success">41</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="41">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="42"><span class="badge badge-success">42</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="42">true</span><span class="stryker-original-code" data-mutant="41"><span class="stryker-original-code" data-mutant="42"><span class="bg-warning-light">todo.title</span></span></span><span class="bg-warning-light"> ? &#039;put&#039; : &#039;delete&#039;](todo)
				.then(function success() {}, function error() </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="43"><span class="badge badge-warning">43</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="43">{
}</span><span class="stryker-original-code" data-mutant="43"><span class="bg-warning-light">{
					todo.title = $scope.originalTodo.title;
				}</span></span><span class="bg-warning-light">)
				.finally(function () </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="44"><span class="badge badge-danger">44</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="44">{
}</span><span class="stryker-original-code" data-mutant="44"><span class="bg-danger-light">{
					$scope.editedTodo = null;
				}</span></span><span class="bg-warning-light">);
		}</span></span><span class="bg-warning-light">;

		$scope.revertEdits = function (todo) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="45"><span class="badge badge-success">45</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="45">{
}</span><span class="stryker-original-code" data-mutant="45"><span class="bg-warning-light">{
			todos[todos.indexOf(todo)] = $scope.originalTodo;
			$scope.editedTodo = null;
			$scope.originalTodo = null;
			$scope.reverted = </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="46"><span class="badge badge-danger">46</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="46">false</span><span class="stryker-original-code" data-mutant="46"><span class="bg-danger-light">true</span></span><span class="bg-warning-light">;
		}</span></span><span class="bg-warning-light">;

		$scope.removeTodo = function (todo) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="47"><span class="badge badge-danger">47</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="47">{
}</span><span class="stryker-original-code" data-mutant="47"><span class="bg-danger-light">{
			store.delete(todo);
		}</span></span><span class="bg-warning-light">;

		$scope.saveTodo = function (todo) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: TimedOut" data-mutant-status-annotation="warning" data-mutant-status="3" data-mutant="48"><span class="badge badge-warning">48</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="48">{
}</span><span class="stryker-original-code" data-mutant="48"><span class="bg-warning-light">{
			store.put(todo);
		}</span></span><span class="bg-warning-light">;

		$scope.toggleCompleted = function (todo, completed) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="49"><span class="badge badge-success">49</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="49">{
}</span><span class="stryker-original-code" data-mutant="49"><span class="bg-warning-light">{
			if (</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="50"><span class="badge badge-success">50</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="50">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="51"><span class="badge badge-danger">51</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="51">true</span><span class="stryker-original-code" data-mutant="50"><span class="stryker-original-code" data-mutant="51"><span class="bg-danger-light">angular.isDefined(completed)</span></span></span><span class="bg-warning-light">) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="52"><span class="badge badge-success">52</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="52">{
}</span><span class="stryker-original-code" data-mutant="52"><span class="bg-warning-light">{
				todo.completed = completed;
			}</span></span><span class="bg-warning-light">
			store.put(todo, todos.indexOf(todo))
				.then(function success() {}, function error() </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="53"><span class="badge badge-danger">53</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="53">{
}</span><span class="stryker-original-code" data-mutant="53"><span class="bg-danger-light">{
					todo.completed = </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BooleanSubstitution" data-content="status: NoCoverage" data-mutant-status-annotation="danger" data-mutant-status="0" data-mutant="54"><span class="badge badge-danger">54</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="54">todo.completed</span><span class="stryker-original-code" data-mutant="54"><span class="bg-danger-light">!todo.completed</span></span><span class="bg-danger-light">;
				}</span></span><span class="bg-warning-light">);
		}</span></span><span class="bg-warning-light">;

		$scope.clearCompletedTodos = function () </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="55"><span class="badge badge-success">55</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="55">{
}</span><span class="stryker-original-code" data-mutant="55"><span class="bg-warning-light">{
			store.clearCompleted();
		}</span></span><span class="bg-warning-light">;

		$scope.markAll = function (completed) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="56"><span class="badge badge-success">56</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="56">{
}</span><span class="stryker-original-code" data-mutant="56"><span class="bg-warning-light">{
			todos.forEach(function (todo) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="57"><span class="badge badge-success">57</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="57">{
}</span><span class="stryker-original-code" data-mutant="57"><span class="bg-warning-light">{
				if (</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="58"><span class="badge badge-success">58</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="58">false</span><a href="#" class="stryker-mutant-button" tabindex="0" title="RemoveConditionals" data-content="status: Survived" data-mutant-status-annotation="danger" data-mutant-status="2" data-mutant="59"><span class="badge badge-danger">59</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="59">true</span><a href="#" class="stryker-mutant-button" tabindex="0" title="BinaryOperator" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="60"><span class="badge badge-success">60</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="60">todo.completed === completed</span><span class="stryker-original-code" data-mutant="58"><span class="stryker-original-code" data-mutant="59"><span class="stryker-original-code" data-mutant="60"><span class="bg-danger-light">todo.completed !== completed</span></span></span></span><span class="bg-warning-light">) </span><a href="#" class="stryker-mutant-button" tabindex="0" title="BlockStatement" data-content="status: Killed" data-mutant-status-annotation="success" data-mutant-status="1" data-mutant="61"><span class="badge badge-success">61</span></a><span class="badge badge-info stryker-mutant-replacement" hidden="hidden" data-mutant="61">{
}</span><span class="stryker-original-code" data-mutant="61"><span class="bg-warning-light">{
					$scope.toggleCompleted(todo, completed);
				}</span></span><span class="bg-warning-light">
			}</span></span><span class="bg-warning-light">);
		}</span></span><span class="bg-warning-light">;
	}</span></span><span class="bg-null">);</span>
</code></pre></div>
<div class="col-lg-5"><table class="table table-sm table-hover mutant-table"><thead><tr><th>#</th>
<th>Mutator</th>
<th>State</th>
<th>Location</th>
<th>Original</th>
<th>Replacement</th></tr></thead>
<tbody><tr><th>0</th>
<td>BlockStatement</td>
<td>TimedOut</td>
<td>8
:
81</td>
<td><code>{
		...;
	}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>1</th>
<td>BlockStatement</td>
<td>TimedOut</td>
<td>16
:
37</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>2</th>
<td>BooleanSubstitution</td>
<td>TimedOut</td>
<td>17
:
65</td>
<td><code></code></td>
<td><code></code></td></tr>
<tr><th>3</th>
<td>BinaryOperator</td>
<td>TimedOut</td>
<td>18
:
27</td>
<td><code>.    ...    .</code></td>
<td><code>.    ...    .</code></td></tr>
<tr><th>4</th>
<td>BooleanSubstitution</td>
<td>TimedOut</td>
<td>19
:
23</td>
<td><code>!$     .</code></td>
<td><code>$     .</code></td></tr>
<tr><th>5</th>
<td>BooleanSubstitution</td>
<td>TimedOut</td>
<td>20
:
5</td>
<td><code></code></td>
<td><code></code></td></tr>
<tr><th>6</th>
<td>BlockStatement</td>
<td>TimedOut</td>
<td>23
:
48</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>7</th>
<td>LogicalOperator</td>
<td>TimedOut</td>
<td>24
:
32</td>
<td><code>$    ...|| ''</code></td>
<td><code>$    ...&& ''</code></td></tr>
<tr><th>8</th>
<td>BinaryOperator</td>
<td>Killed</td>
<td>25
:
26</td>
<td><code>=== '      '</code></td>
<td><code>!== '      '</code></td></tr>
<tr><th>9</th>
<td>RemoveConditionals</td>
<td>TimedOut</td>
<td>25
:
26</td>
<td><code>=== '      '</code></td>
<td><code></code></td></tr>
<tr><th>10</th>
<td>RemoveConditionals</td>
<td>TimedOut</td>
<td>25
:
26</td>
<td><code>=== '      '</code></td>
<td><code></code></td></tr>
<tr><th>11</th>
<td>BooleanSubstitution</td>
<td>Killed</td>
<td>26
:
17</td>
<td><code></code></td>
<td><code></code></td></tr>
<tr><th>12</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>26
:
28</td>
<td><code>=== '         '</code></td>
<td><code></code></td></tr>
<tr><th>13</th>
<td>BinaryOperator</td>
<td>Killed</td>
<td>26
:
28</td>
<td><code>=== '         '</code></td>
<td><code>!== '         '</code></td></tr>
<tr><th>14</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>26
:
28</td>
<td><code>=== '         '</code></td>
<td><code></code></td></tr>
<tr><th>15</th>
<td>BooleanSubstitution</td>
<td>Killed</td>
<td>27
:
17</td>
<td><code></code></td>
<td><code></code></td></tr>
<tr><th>16</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>30
:
31</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>17</th>
<td>BooleanSubstitution</td>
<td>Survived</td>
<td>33
:
15</td>
<td><code></code></td>
<td><code></code></td></tr>
<tr><th>18</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>36
:
7</td>
<td><code>!       .</code></td>
<td><code></code></td></tr>
<tr><th>19</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>36
:
7</td>
<td><code>!       .</code></td>
<td><code></code></td></tr>
<tr><th>20</th>
<td>BooleanSubstitution</td>
<td>Killed</td>
<td>36
:
7</td>
<td><code>!       .</code></td>
<td><code>.</code></td></tr>
<tr><th>21</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>36
:
23</td>
<td><code>{
		...
			}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>22</th>
<td>BooleanSubstitution</td>
<td>Survived</td>
<td>40
:
19</td>
<td><code></code></td>
<td><code></code></td></tr>
<tr><th>23</th>
<td>BlockStatement</td>
<td>Survived</td>
<td>42
:
29</td>
<td><code>{
		...				}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>24</th>
<td>BlockStatement</td>
<td>Survived</td>
<td>45
:
25</td>
<td><code>{
		...				}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>25</th>
<td>BooleanSubstitution</td>
<td>Survived</td>
<td>46
:
21</td>
<td><code></code></td>
<td><code></code></td></tr>
<tr><th>26</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>50
:
36</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>27</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>56
:
44</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>28</th>
<td>RemoveConditionals</td>
<td>Survived</td>
<td>59
:
7</td>
<td><code>=== '...    '</code></td>
<td><code></code></td></tr>
<tr><th>29</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>59
:
7</td>
<td><code>=== '...    '</code></td>
<td><code></code></td></tr>
<tr><th>30</th>
<td>LogicalOperator</td>
<td>Survived</td>
<td>59
:
7</td>
<td><code>=== '...    '</code></td>
<td><code>=== '...    '</code></td></tr>
<tr><th>31</th>
<td>BinaryOperator</td>
<td>Survived</td>
<td>59
:
7</td>
<td><code>=== '    '</code></td>
<td><code>!== '    '</code></td></tr>
<tr><th>32</th>
<td>BinaryOperator</td>
<td>Survived</td>
<td>59
:
27</td>
<td><code>$    ...    '</code></td>
<td><code>$    ...    '</code></td></tr>
<tr><th>33</th>
<td>BlockStatement</td>
<td>Survived</td>
<td>59
:
58</td>
<td><code>{
		...
			}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>34</th>
<td>RemoveConditionals</td>
<td>Survived</td>
<td>66
:
7</td>
<td><code>$     .</code></td>
<td><code></code></td></tr>
<tr><th>35</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>66
:
7</td>
<td><code>$     .</code></td>
<td><code></code></td></tr>
<tr><th>36</th>
<td>BlockStatement</td>
<td>Survived</td>
<td>66
:
24</td>
<td><code>{
		...
			}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>37</th>
<td>RemoveConditionals</td>
<td>Survived</td>
<td>74
:
7</td>
<td><code>.    ...    .</code></td>
<td><code></code></td></tr>
<tr><th>38</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>74
:
7</td>
<td><code>.    ...    .</code></td>
<td><code></code></td></tr>
<tr><th>39</th>
<td>BinaryOperator</td>
<td>Killed</td>
<td>74
:
7</td>
<td><code>.    ...    .</code></td>
<td><code>.    ...    .</code></td></tr>
<tr><th>40</th>
<td>BlockStatement</td>
<td>Survived</td>
<td>74
:
49</td>
<td><code>{
		...
			}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>41</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>79
:
9</td>
<td><code>.</code></td>
<td><code></code></td></tr>
<tr><th>42</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>79
:
9</td>
<td><code>.</code></td>
<td><code></code></td></tr>
<tr><th>43</th>
<td>BlockStatement</td>
<td>TimedOut</td>
<td>80
:
50</td>
<td><code>{
		...				}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>44</th>
<td>BlockStatement</td>
<td>Survived</td>
<td>83
:
25</td>
<td><code>{
		...				}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>45</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>88
:
39</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>46</th>
<td>BooleanSubstitution</td>
<td>Survived</td>
<td>92
:
21</td>
<td><code></code></td>
<td><code></code></td></tr>
<tr><th>47</th>
<td>BlockStatement</td>
<td>Survived</td>
<td>95
:
38</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>48</th>
<td>BlockStatement</td>
<td>TimedOut</td>
<td>99
:
36</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>49</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>103
:
54</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>50</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>104
:
7</td>
<td><code>.    ...    )</code></td>
<td><code></code></td></tr>
<tr><th>51</th>
<td>RemoveConditionals</td>
<td>Survived</td>
<td>104
:
7</td>
<td><code>.    ...    )</code></td>
<td><code></code></td></tr>
<tr><th>52</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>104
:
37</td>
<td><code>{
		...
			}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>53</th>
<td>BlockStatement</td>
<td>Survived</td>
<td>108
:
50</td>
<td><code>{
		...				}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>54</th>
<td>BooleanSubstitution</td>
<td>NoCoverage</td>
<td>109
:
22</td>
<td><code>!    .</code></td>
<td><code>.</code></td></tr>
<tr><th>55</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>113
:
43</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>56</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>117
:
40</td>
<td><code>{
		...
		}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>57</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>118
:
33</td>
<td><code>{
		...
			}</code></td>
<td><code>{
}</code></td></tr>
<tr><th>58</th>
<td>RemoveConditionals</td>
<td>Killed</td>
<td>119
:
8</td>
<td><code>.          !==</code></td>
<td><code></code></td></tr>
<tr><th>59</th>
<td>RemoveConditionals</td>
<td>Survived</td>
<td>119
:
8</td>
<td><code>.          !==</code></td>
<td><code></code></td></tr>
<tr><th>60</th>
<td>BinaryOperator</td>
<td>Killed</td>
<td>119
:
8</td>
<td><code>.          !==</code></td>
<td><code>.          ===</code></td></tr>
<tr><th>61</th>
<td>BlockStatement</td>
<td>Killed</td>
<td>119
:
38</td>
<td><code>{
		...				}</code></td>
<td><code>{
}</code></td></tr></tbody></table></div></div></div></div>
<footer>Generated with stryker-html-reporter generator. Visit the 
<a href="http://stryker-mutator.github.io" target="_blank">Stryker website</a></footer></div>
<script src="../strykerResources/popper.js/dist/umd/popper.min.js" defer="defer"></script>
<script src="../strykerResources/jquery/dist/jquery.slim.min.js" defer="defer"></script>
<script src="../strykerResources/bootstrap/js/bootstrap.min.js" defer="defer"></script>
<script src="../strykerResources/stryker.js" defer="defer"></script></body></html>